# Visualization
TKV3d
AIS

# AIS_ParallelRelation Class Reference

A framework to display constraints of parallelism
between two or more Interactive Objects. These
entities can be faces or edges.
.

`#include <AIS_ParallelRelation.hxx>`

Inheritance diagram for AIS_ParallelRelation:

[legend]

## Public Member Functions

Standard_EXPORT | AIS_ParallelRelation (const TopoDS_Shape &aFShape, const TopoDS_Shape &aSShape, const Handle(Geom_Plane)&aPlane)
| Constructs an object to display parallel constraints. This object is defined by the first shape aFShape and the second shape aSShape and the plane aPlane. .
Standard_EXPORT | AIS_ParallelRelation (const TopoDS_Shape &aFShape, const TopoDS_Shape &aSShape, const Handle(Geom_Plane)&aPlane, const gp_Pnt &aPosition, const DsgPrs_ArrowSide aSymbolPrs, const Standard_Real anArrowSize=0.01)
| Constructs an object to display parallel constraints. This object is defined by the first shape aFShape and the second shape aSShape the plane aPlane, the position aPosition, the type of arrow, aSymbolPrs and its size anArrowSize. .
virtual Standard_Boolean | IsMovable () const
| Returns true if the parallelism is movable. .
virtual Standard_EXPORT void | Compute (const Handle(Prs3d_Projector)&aProjector, const Handle(Geom_Transformation)&aTrsf, const Handle(Prs3d_Presentation)&aPresentation)
| computes the presentation according to a point of view given by <aprojector>. To be Used when the associated degenerated Presentations have been transformed by <atrsf> which is not a Pure Translation. The HLR Prs can't be deducted automatically WARNING :<atrsf> must be applied to the object to display before computation !!!
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Private Member Functions

Standard_EXPORT void | Compute (const Handle(PrsMgr_PresentationManager3d)&aPresentationManager, const Handle(Prs3d_Presentation)&aPresentation, const Standard_Integer aMode=0)
| Calculates the 3D view aPresentation and its updates. The latter are managed by aPresentationManager. aPresentableObject has the display mode aMode; this has the default value of 0, that is, the wireframe display mode. .
Standard_EXPORT void | Compute (const Handle(Prs3d_Projector)&aProjector, const Handle(Prs3d_Presentation)&aPresentation)

Calculates the 3D view aPresentation and its
updates. The latter are managed by
aPresentationManager. Each of the views in the
viewer and every modification such as rotation, for
example, entails recalculation.
It must be redefined to implement hidden line removal
for the object. The user never calls this method
himself. This is done via the InteractiveContext object
and is dependent on the point of view from which the
object is displayed.
.

Standard_EXPORT void | Compute (const Handle(PrsMgr_PresentationManager2d)&aPresentationManager, const Handle(Graphic2d_GraphicObject)&aPresentation, const Standard_Integer aMode=0)
| Calculates the 2D view aPresentation and its updates. The latter are managed by aPresentationManager. aPresentableObject has the display mode aMode; this has the default value of 0, that is, the wireframe display mode. Note that this syntax is not used in AIS as that package only concerns 3D display. .
Standard_EXPORT void | ComputeSelection (const Handle(SelectMgr_Selection)&aSelection, const Standard_Integer aMode)

Recovers and calculates any sensitive primitive,
aSelection, available in Shape mode, specified by
aMode. As a rule, these are sensitive faces.
This method is defined as virtual. This enables you to
implement it in the creation of a new class of AIS
Interactive Object. You need to do this and in so
doing, redefine this method, if you create a class
which enriches the list of signatures and types.
.

Standard_EXPORT void | ComputeTwoFacesParallel (const Handle(Prs3d_Presentation)&aPresentation)
Standard_EXPORT void | ComputeTwoEdgesParallel (const Handle(Prs3d_Presentation)&aPresentation)

## Private Attributes

gp_Pnt | myFAttach
gp_Pnt | mySAttach
gp_Dir | myDirAttach

## Constructor & Destructor Documentation

Standard_EXPORT AIS_ParallelRelation::AIS_ParallelRelation | ( | const TopoDS_Shape & | aFShape,
|  | const TopoDS_Shape & | aSShape,
|  | const Handle(Geom_Plane)& | aPlane
| ) |

Standard_EXPORT AIS_ParallelRelation::AIS_ParallelRelation | ( | const TopoDS_Shape & | aFShape,
|  | const TopoDS_Shape & | aSShape,
|  | const Handle(Geom_Plane)& | aPlane,
|  | const gp_Pnt & | aPosition,
|  | const DsgPrs_ArrowSide | aSymbolPrs,
|  | const Standard_Real | anArrowSize = `0.01`
| ) |

## Member Function Documentation

Standard_EXPORT void AIS_ParallelRelation::Compute | ( | const Handle(PrsMgr_PresentationManager2d)& | aPresentationManager,
|  | const Handle(Graphic2d_GraphicObject)& | aPresentation,
|  | const Standard_Integer | aMode = `0`
| ) | `[private, virtual]`

| Reimplemented from PrsMgr_PresentableObject.

Standard_EXPORT void AIS_ParallelRelation::Compute | ( | const Handle(Prs3d_Projector)& | aProjector,
|  | const Handle(Prs3d_Presentation)& | aPresentation
| ) | `[private, virtual]`

| Reimplemented from PrsMgr_PresentableObject.

Standard_EXPORT void AIS_ParallelRelation::Compute | ( | const Handle(PrsMgr_PresentationManager3d)& | aPresentationManager,
|  | const Handle(Prs3d_Presentation)& | aPresentation,
|  | const Standard_Integer | aMode = `0`
| ) | `[private, virtual]`

| Reimplemented from PrsMgr_PresentableObject.

virtual Standard_EXPORT void AIS_ParallelRelation::Compute | ( | const Handle(Prs3d_Projector)& | aProjector,
|  | const Handle(Geom_Transformation)& | aTrsf,
|  | const Handle(Prs3d_Presentation)& | aPresentation
| ) | `[virtual]`

| Reimplemented from PrsMgr_PresentableObject.

Standard_EXPORT void AIS_ParallelRelation::ComputeSelection | ( | const Handle(SelectMgr_Selection)& | aSelection,
|  | const Standard_Integer | aMode
| ) | `[private, virtual]`

| Implements SelectMgr_SelectableObject.

Standard_EXPORT void AIS_ParallelRelation::ComputeTwoEdgesParallel | ( | const Handle(Prs3d_Presentation)& | aPresentation | ) | `[private]`

Standard_EXPORT void AIS_ParallelRelation::ComputeTwoFacesParallel | ( | const Handle(Prs3d_Presentation)& | aPresentation | ) | `[private]`

Standard_EXPORT const AIS_ParallelRelation::Handle | ( | Standard_Type |  | ) | const

| Reimplemented from AIS_Relation.

Standard_Boolean AIS_ParallelRelation::IsMovable | ( |  | ) | const`[inline, virtual]`

| Reimplemented from AIS_Relation.

## Field Documentation

gp_Dir AIS_ParallelRelation::myDirAttach `[private]`

gp_Pnt AIS_ParallelRelation::myFAttach `[private]`

gp_Pnt AIS_ParallelRelation::mySAttach `[private]`

The documentation for this class was generated from the following files:

- AIS_ParallelRelation.hxx
- AIS_ParallelRelation.lxx